<?php
require_once 'config.php';
require_once 'structs.php';
require_once 'database.php';
require_once 'utils_add.php';

function prepareGlobals() {
global $metaNameList;

	$metaNameList = getMetaList();
}

function prepareArguments() {
global $mainMeta;
global $metaNameList;
global $metaFilter;

	// if there's no POST message, we want to switch all filters to
	// 'accept'. Otherwise, we use whatever was sent.
	if (count($_POST) == 0) {
		$filterClear = 1;
	} else {
		$filterClear = 0;
	}
	//
	$mainMeta = $_GET['meta'];
	$metaFilter = $metaNameList;	// copy array of all filters
	foreach($metaFilter as &$mf) {	// note: & to get references to array
		$mf = $filterClear;
	}
	//
	foreach($_POST as $id=>$check) {
		if ($check = "on") {
			$metaFilter[$id] = 1;
		}
	}
	//
	if ($_GET['showall']) {
		$mainMeta = -1;
	}
}

function executeArguments() {
global $mainMeta;
global $metaNameList;
global $metaFilter;

	if ($_GET['addurl']) {
                $bml = BookmarkLink::parsePost();
                addBookmark(0,$bml);

		// refresh globals so the metatag list etc is up-to-date
		// because addUrl can affect it.
		prepareGlobals();
	
		$metaFilter = $metaNameList;
		foreach($metaFilter as &$mf) {
			$mf = 1;
		}

		$ml = parseMetaList($meta);
		$mainMeta = getMetaTag($ml[0]);
	}
}

function url($cmd, $param) {
	return "?$cmd=$param";
}

function anchor($cmd, $param, $txt) {
	return "<a href=".url($cmd,$param).">$txt</a>";
}

function renderMetaList() {
global $metaNameList;
	print anchor("showall","1", "Show All");
	print "<br/><br/>\n";
	foreach($metaNameList as $id=>$m) {
		print anchor("meta",$id, $m)."<br/>\n";
	}
}

function renderMetaOptionsForm() {
global $metaNameList;
global $mainMeta;
global $metaFilter;
	$html = "<form method=post action=".url("meta",$mainMeta).">";
	foreach($metaNameList as $id=>$m) {
		$c = ($metaFilter[$id]==1) ? "checked" : "";
		$html .= "| <input type=checkbox name=$id $c>$m |";
	}
	$html.= "<input type=submit value=Filter>";
	$html.= "</form>\n";
	print $html;
}

function renderBookmarkList() {
global $metaFilter;
global $mainMeta;
global $metaNameList;

	$tagList = array();
	//$tagList = $metaFilter;
	$tagList[] = $mainMeta;

	$bmList = getBookmark(0, $mainMeta==-1?NULL:$tagList, $metaFilter);
	print "<table border=0 cellborder=0 cellspacing=0 width=100%>";
	$bgcol="#ddddff";
	foreach($bmList as $bm) {
		$row = "<tr bgcolor=$bgcol><td><a href=".$bm->url.">".($bm->description==""?$bm->url:$bm->description)."</a></td>";
		$row.= "<td>".$bm->notes."</td></tr>";
		$row.= "<tr><td></td><td bgcolor=$bgcol align=right>Meta: ";

		foreach($bm->metaList as $id) {
			$row.= anchor("meta",$id, $metaNameList[$id])." ";
		}

		$row.= "</td></tr>";
		$row.= "<tr><td colspan=3></td></tr>";

		print $row;
	}
	print "</table>";
}

function renderAddBookmark() {
global $secretKey;
	print getAddBookmarkCode(url(addurl,$secretKey));
}

prepareGlobals();
prepareArguments();
executeArguments();

print "<table border=0 width=100%><tr valign=top><td align=center bgcolor=#000000>";
print "<a href=http://www.minervahome.net/moonbeam><img src=mblogo.png alt='Minerva Bookmark Manager' border=0/></a>";
print "</td><td bgcolor=#dddddd>";
print "<a href=http://www.minervahome.net/moonbeam><img src=mbtitle.png alt='Minerva Bookmark Manager' border=0/></a>";
print "</td></tr><tr valign=top ><td rowspan=2 bgcolor=#dddddd>";
renderMetaList();
print "</td><td>";
print "<hr>";
renderMetaOptionsForm();
print "<hr>";
print "<b>".$metaNameList[$mainMeta]."</b>  ";
print renderBookmarkList();
print "</td></tr></table>";
print "<br/>";
renderAddBookmark();
?>

